package net.minecraft.world.level.levelgen.placement.nether;

import net.minecraft.world.level.levelgen.feature.configurations.DecoratorConfiguration;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import net.minecraft.core.BlockPos;
import java.util.Random;
import com.mojang.datafixers.Dynamic;
import java.util.function.Function;
import net.minecraft.world.level.levelgen.feature.configurations.CountRangeDecoratorConfiguration;
import net.minecraft.world.level.levelgen.placement.SimpleFeatureDecorator;

public class CountRangeDecorator extends SimpleFeatureDecorator<CountRangeDecoratorConfiguration> {
    public CountRangeDecorator(final Function<Dynamic<?>, ? extends CountRangeDecoratorConfiguration> function) {
        super(function);
    }
    
    public Stream<BlockPos> place(final Random random, final CountRangeDecoratorConfiguration cgi, final BlockPos fk) {
        final int integer5;
        final int integer6;
        final int integer7;
        return IntStream.range(0, cgi.count).<BlockPos>mapToObj(integer -> {
            integer5 = random.nextInt(16) + fk.getX();
            integer6 = random.nextInt(16) + fk.getZ();
            integer7 = random.nextInt(cgi.maximum - cgi.topOffset) + cgi.bottomOffset;
            return new BlockPos(integer5, integer7, integer6);
        });
    }
}
